#pragma once

#include <filesystem>

// Base Class
#include "EntityInstance.h"
#include "detail/EntitySnapshotBase.h"
#include "detail/mixins/DiskStorageMixin.h"
#include "detail/mixins/MongoDBStorageMixin.h"

namespace armarx::armem::server::ltm
{

    class EntitySnapshot :
        public detail::EntitySnapshotBase<EntityInstance>,
        public detail::mixin::DiskMemoryItemMixin,
        public detail::mixin::MongoDBStorageMixin
    {
    public:
        EntitySnapshot(const detail::mixin::Path&,
                       const detail::mixin::MongoDBSettings&,
                       const std::string&,
                       const MemoryID& id,
                       const std::shared_ptr<Processors>& p);

        bool forEachInstance(std::function<void(EntityInstance&)> func) const override;
        bool hasInstance(const int) const override;
        std::shared_ptr<EntityInstance> findInstance(const int) const override;

    protected:
        void _loadAllReferences(armem::wm::EntitySnapshot&) const override;
        void _resolve(armem::wm::EntitySnapshot&) const override;
        void _store(const armem::wm::EntitySnapshot&) override;

    private:
    };

} // namespace armarx::armem::server::ltm
