/*
 * This file is part of ArmarX.
 *
 * Copyright (C) 2012-2016, High Performance Humanoid Technologies (H2T),
 * Karlsruhe Institute of Technology (KIT), all rights reserved.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Fabian Peller-Konrad (fabian dot peller-konrad at kit dot edu)
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#pragma once

#include "AronGeneratedClass.h"


namespace armarx::aron::cpp
{
    class AronGeneratedIntEnumBase : public AronGeneratedClass
    {
    public:
        AronGeneratedIntEnumBase() = default;
        virtual ~AronGeneratedIntEnumBase() = default;

        /// Convert the current bo to an aron variant data dict
        virtual armarx::aron::data::IntPtr toAron() const = 0;

        /// Convert the current bo to the ice representation of an aron variant data dict
        virtual armarx::aron::data::dto::AronIntPtr toAronDTO() const = 0;

        /// Set all members of the current bo according to the aron variant data dict
        virtual void fromAron(const armarx::aron::data::IntPtr& input) = 0;

        /// Set all members of the current bo according to the ice representation of an aron variant data dict
        virtual void fromAron(const armarx::aron::data::dto::AronIntPtr& input) = 0;
    };

    template <class Derived>
    class AronGeneratedIntEnum :
            public AronGeneratedIntEnumBase
    {
    public:

    };

    template <class T>
    concept isAronGeneratedIntEnum = std::is_base_of<AronGeneratedIntEnumBase, T>::value;
}

namespace armarx::aron::codegenerator::cpp
{
    using AronGeneratedIntEnumBase = aron::cpp::AronGeneratedIntEnumBase;

    template <class Derived>
    using AronGeneratedIntEnum = aron::cpp::AronGeneratedIntEnum<Derived>;
}
